﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;

namespace Revision.Models
{
    /// <summary>
    /// Base class for all questions and answers
    /// </summary>
    public abstract class BaseQA
    {
        /// <summary>
        /// Should all text be redacted (to protect copyright?)
        /// </summary>
        public bool IsTextRedacted { get; set; }

        /// <summary>
        /// If RedactedText == true, converts all recognisable text to XXX
        /// </summary>
        protected string ProcessText(string text)
        {
            if (!IsTextRedacted)
                return text;

            string junk = text;
            
            // Convert 
            //    "and" into ZZZ 
            //    "the" into zzz 
            junk = junk.Replace("and", "ZZZ")
                       .Replace("the", "zzz");

            // Convert every character except Z into X. Should be hard enough to read...
            junk = Regex.Replace(junk, "[A-Y]", "X");
            junk = Regex.Replace(junk, "[a-y]", "x");

            // Convert back to "and" and "the", just to mess with them.
            junk = junk.Replace("ZZZ", "and")
                       .Replace("zzz", "the");

            return junk;
        }
    }
}