﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Revision.Models.ViewModels
{
    /// <summary>
    /// Viewing model for _SectionLink.cshtml - displays links to this section
    /// </summary>
    public class SectionView
    {
        /// <summary>
        /// Section name eg. "Section 3: Designing and implementing WCF Services"
        /// </summary>
        public string SectionName   { get; set; }

        /// <summary>
        /// Exam code eg. "70-487"
        /// </summary>
        public string ExamCode      { get; set; }

        /// <summary>
        /// Section number eg. "1", or "" for all sections
        /// </summary>
        public string SectionNumber { get; set; }

        /// <summary>
        /// Viewing model for _SectionLink.cshtml - displays links to this section
        /// </summary>
        public SectionView(string examcode, string sectionNumber, string sectionName)
        {
            SectionName   = sectionName;
            ExamCode      = examcode;
            SectionNumber = sectionNumber;
        }
    }
}