﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Revision.Models.ViewModels
{
    /// <summary>
    /// Viewing model for the Exam Tips page
    /// </summary>
    public class TipView
    {
        public TipView() {}

        public TipView(Exam exam, string section)
        {
            ThisExam = exam;

            // Only display tips for this section
            Tips = exam.ExamTips;

            if (!string.IsNullOrWhiteSpace(section))
            {
                Tips = Tips.Where(t => t.SectionNumber.StartsWith(section))
                           .ToList();
            }
        }

        /// <summary>
        /// The examination being taken
        /// </summary>
        public Exam ThisExam { get; set; }

        /// <summary>
        /// Tips to be displayed
        /// </summary>
        public List<Tip> Tips { get; set; }
    }
}