﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Revision.Utilities
{
    /// <summary>
    /// General utility methods and extensions
    /// </summary>
    public static class Utils
    {
        private static Random rng = new Random(DateTime.Now.Millisecond);

        /// <summary>
        /// Randomly shuffles the list
        /// </summary>
        public static void Shuffle<T>(this IList<T> list)
        {
            for (int n = 0; n < list.Count; ++n)
            {
                int k = rng.Next(list.Count);

                T value = list[k];
                list[k] = list[n];
                list[n] = value;
            }
        }

        /// <summary>
        /// Returns the Nth item in the list, or default(T)
        /// </summary>
        public static T Nth<T>(this IEnumerable<T> allItems, int n)
        {
            List<T> list = allItems.ToList();

            if (n < 1 || n > list.Count)
                return default(T);

            return list[n - 1];
        }


    }
}